########################################################################
# Copyright (c) 2004 by Hartmut Schwarz, matut@matut-spielwerk.de
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2 
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA 02111-1307, USA.
########################################################################

# various functions used by other script

# replace special characters by HTML entities
proc replace_entities { text } {
 regsub -all {} $text {\&auml;} text;
 regsub -all {} $text {\&ouml;} text;
 regsub -all {} $text {\&uuml;} text;
 regsub -all {} $text {\&Auml;} text;
 regsub -all {} $text {\&Ouml;} text;
 regsub -all {} $text {\&Uuml;} text;
 regsub -all {} $text {\&szlig;} text;
 regsub -all {} $text {\&egrave;} text;
 return $text;
}

# replace special characters by ascii characters
proc replace_ascii { text } {
 regsub -all {} $text {ae} text;
 regsub -all {} $text {oe} text;
 regsub -all {} $text {ue} text;
 regsub -all {} $text {Ae} text;
 regsub -all {} $text {Oe} text;
 regsub -all {} $text {Ue} text;
 regsub -all {} $text {ss} text;
 regsub -all {} $text {e} text;
 return $text;
}

# find mix mode in argument list
proc eval_mix_mode {} {
 global argv;
 set mode "";
 set i [lsearch -exact $argv "-IR"];
 if { $i >= 0 } {
  set mode "-IR"; # left/right (stereo) + main signal room response
  set argv [lreplace $argv $i $i];
 }
 set i [lsearch -exact $argv "-ST"];
 if { $i >= 0 } {
  if { $mode != "" } {
   return "ERROR"
  }
  set mode "-ST"; # left/right (stereo) without room response
  set argv [lreplace $argv $i $i];
 }
 set i [lsearch -exact $argv "-MA"];
 if { $i >= 0 } {
  if { $mode != "" } {
   return "ERROR"
  }
  set mode "-MA"; # main (mono) without room response
  set argv [lreplace $argv $i $i];
 }
 if { $mode == "" } {
  set mode "-ST"; # default
 }
 return $mode;
}
