; --------------------------------------------------------------------------------
; Copyright (c) 2002 by Hartmut Schwarz               matut@matut-spielwerk.de
;
; This program is free software; you can redistribute it and/or
; modify it under the terms of the GNU General Public License
; as published by the Free Software Foundation; either version 2 
; of the License, or (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public
; License along with this program; if not, write to the Free
; Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
; MA 02111-1307, USA.
; --------------------------------------------------------------------------------

sr     = 44100
kr     =  4410
ksmps  =    10
nchnls =     2

; --------------------------------------------------------------------------------
         instr 1 ; Eine Trompete
; --------------------------------------------------------------------------------
         ; Parameter
idur     = p3         ; Dauer
iamp     = ampdb(p4)  ; Amplitude aus dB-Wert
icps     = cpspch(p5) ; Fequenz aus Tonhoehe
imix     = p6         ; Mixfaktor
idst     = p7         ; Hoerabstand
iazm     = p8         ; Richtungswinkel
isze     = p9         ; Groessenfaktor
iang     = p10        ; Aufstellungswinkel
         ; genutzte Tabellen
ift1     =  1                                        ; Sinustabelle fuer Oszillator
         ; weitere Konstanten
ibalance = .5         ; Kanal-Balance ( 0 = links ... 1 = rechts )
         ; Amplituden-Verlauf
kenv     linseg 0, .2*p3, 1, .2*p3, .75, .5*p3, .5, .1*p3, 0        ; Einhuellende
kamp     = imix*kenv*iamp                                   ; Verlauf Amplitude
kind     = kenv*9                                           ; und Modulationsindex
         ; compose signals main, left, right
amain    foscili kamp, icps, 1, 1, kind, ift1 ; FM Oszillator
aleft    = (1 - ibalance)*amain
aright   = ibalance*amain
         ; signal output
outs     aleft, aright
endin ; --------------------------------------------------------------------------
