# ----------------------------------------------------------------------------
# Csound Tcl Partitur-Skript      "Menuet v. Rameau"               SEP-21-2002
# Copyright (c) 2002 by Hartmut Schwarz               matut@matut-spielwerk.de
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2 
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA 02111-1307, USA.
#
# ----------------------------------------------------------------------------

# ------------------------------------ ins Tcl-Arbeitsverzeichnis wechseln ---
cd "[file dirname $argv0]/..";

# ------------------------------------------- allgemeine Grundlagen lernen ---
source "basics/ref.tcl";   # alles ueber Referenzvariablen
source "basics/tree.tcl";  # alles ueber Datenbaeume

# --------------------------------- die Grundlagen der Csound-Musik lernen ---
source "basics/music.tcl";

# ------------------------------------------------------ das Spiel beginnt ---
set root [plant]; # einen neuen Klangbaum pflanzen
# Jean-Philippe Rameau / Menuet
set stem [sprout $root {kybs 12 vlbs 76 chtv .75 tmtv 2.4 fstp 1}];
set song [sprout $stem\
 {rept 16 cstc .5 vlbs 76 chbt ././. more {\
  {csym (g,f,e,f,d,e)/(C,c,B)   cmod !!!!!!/!!!}\
  {csym (f,e,d,e,c,d)/(A,B,G)   cmod !!!!!!/!!!}\
  {csym (e,g,f,e,d,c)/(c,C)     cmod !_____/_;.}\
  {csym (d,c,B,A,G)/(G,F)       cmod ____=;/_;.}\
  {csym (g,f,e,f,d,e)/(E,A)     cmod !!!!!!/_;.}\
  {csym (f,e,d,e,c,d)/(D,G)     cmod !!!!!!/_;.}\
  {csym (e,g,f,e,d,e)//(c,g,G)  cmod !_____/;/___}\
  {csym (c)/(C)                 cmod ./.}\
 }}\
 {rept 4 cstc .4 vlbs 75 chbt ././. more {\
  {csym (d,c,B,c,A,B)//(G,g,f#) cmod !!!!!!/;/!!!}\
  {csym (c,B,A,B,G,A)/(E,F#,D)  cmod !!!!!!/!!!}\
  {csym (B,d,c,B,A,G)//(g,G)    cmod !_____/;/_;.}\
  {csym (A,G,F#,E,D)/(D,C)      cmod ____=;/_;.}\
 }}\
 {rept 4 cstc .3 vlbs 74 chbt ././. more {\
  {csym (d,c,B,c,A,B)//(B,e)    cmod !!!!!!/;/_;.}\
  {csym (c,B,A,B,G,A)//(A,d)    cmod !!!!!!/;/_;.}\
  {csym (B,d,c,B,A,G)//(G,d,D)  cmod !_____/;/___}\
  {csym (G)//(G,g,f,e,d)        cmod =/;/.;____}\
 }}\
];
begin $root "[file rootname [file tail $argv0]]" 0.5;
touch $stem 32;
end $root 0.5;
return;
