# ----------------------------------------------------------------------------
# Csound Tcl Partitur-Skript "Experiment I"                        NOV-21-2002
# Copyright (c) 2002 by Hartmut Schwarz               matut@matut-spielwerk.de
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2 
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public
# License along with this program; if not, write to the Free
# Software Foundation, Inc., 59 Temple Place, Suite 330, Boston,
# MA 02111-1307, USA.
#
# ----------------------------------------------------------------------------

# ------------------------------------ ins Tcl-Arbeitsverzeichnis wechseln ---
cd "[file dirname $argv0]/..";

# ------------------------------------------- allgemeine Grundlagen lernen ---
source "basics/ref.tcl";   # alles ueber Referenzvariablen
source "basics/tree.tcl";  # alles ueber Datenbaeume

# --------------------------------- die Grundlagen der Csound-Musik lernen ---
source "basics/music.tcl";

# ------------------------------------------------------ das Spiel beginnt ---
set root [plant]; # einen neuen Klangbaum pflanzen

# Experiment I : Quintenzirkel, reine und temperierte Stimmung,
#                12-, 9-, 7-Ton Tonleitern, 8-tel Toene
set stem [TREEnew $root {vlbs 76 tmtv 1 tvtv 6 idst 60}];
sprout $stem\
 {rept 16 more {\
  {song {} vars {\
   {csym {(2:2,3:2,9:4,27:8,81:16,243:32,729:64,2187:128,6561:256,\
           19683:512,59049:1024,177147:2048,531441:4096)} cmod .............}\
   {cmod r.............}\
   {csym {(0,7,14,21,28,35,42,49,56,63,70,77,84)} cmod .............}\
   {cmod r.............}\
   {csym {(2:2,3:2,9:4,27:8,81:16,243:32,729:64,2187:128,6561:256,\
           19683:512,59049:1024,177147:2048,531441:4096)\
         /(0,7,14,21,28,35,42,49,56,63,70,77,84)}\
    cmod ............./.............}\
   {cmod r............./r.............}\
   {csym {(0,7,14,21,28,35,42,49,56,63,70,77,84)\
         /(2:2,3:2,9:4,27:8,81:16,243:32,729:64,2187:128,6561:256,\
           19683:512,59049:1024,177147:2048,531441:4096)}\
    cmod ............./.............}\
   {cmod r............./r.............}\
  }}\
  {kybs {[get_key_by_freq 16.5]}\
   tmtv 4 tvtv 2}\
 }}\
 {rept 10 tmtv 4 tvtv 2 kybs {[get_key_by_freq 264]} more {\
  {vars {\
   {csym {(0,1,2,3,4,5,6,7,8,9,10,11)}\
    cmod ............ chbt .;;;.;;.;.}\
   {cmod r............ chbt ..;.;;.;;;}\
   {csym {(0,1.333,2.667,4,5.333,6.667,8,9.333,10.667)}\
    cmod ......... chbt .;;;.;;.;.}\
   {cmod r......... chbt ..;.;;.;;;}\
   {csym {(0,1.714,3.429,5.143,6.857,8.571,10.286)}\
    cmod ....... chbt .;;;.;;.;.}\
   {cmod r....... chbt ..;.;;.;;;}\
   {csym {(0,2.4,4.8,7.2,9.6)} cmod ..... chbt .;;;.;;.;.}\
   {cmod r..... chbt ..;.;;.;;;}\
   {csym {(0,1,2,3,4,5,6,7,8,9,10,11)\
         /(0,1.333,2.667,4,5.333,6.667,8,9.333,10.667)\
         /(0,1.714,3.429,5.143,6.857,8.571,10.286)\
         /(0,2.4,4.8,7.2,9.6)}\
    cmod ............/......../......./.....\
    chbt .;;;.;;.;./.;;.;./.;./.}\
   {cmod r............/r........./r......./r.....\
    chbt ..;.;;.;;;/..;.;;/..;/.}\
  }}\
 }}\
 {rept 18 more {\
  {song {} vars {\
   {kybs {[get_key_by_freq 16.5]}}\
   {kybs {[get_key_by_freq   33]}}\
   {kybs {[get_key_by_freq   66]}}\
   {kybs {[get_key_by_freq  132]}}\
   {kybs {[get_key_by_freq  264]}}\
   {kybs {[get_key_by_freq  528]}}\
   {kybs {[get_key_by_freq 1056]}}\
   {kybs {[get_key_by_freq 2112]}}\
   {kybs {[get_key_by_freq 4224]}}\
  }}\
  {csym {(1:1,25:24,9:8,6:5,5:4,4:3,25:18,3:2,8:5,5:3,9:5,15:8)}\
   cmod ............}\
 }}\
 {rept 18 more {\
  {song {} vars {\
   {kybs {[get_key_by_freq 4224]}}\
   {kybs {[get_key_by_freq 2112]}}\
   {kybs {[get_key_by_freq 1056]}}\
   {kybs {[get_key_by_freq  528]}}\
   {kybs {[get_key_by_freq  264]}}\
   {kybs {[get_key_by_freq  132]}}\
   {kybs {[get_key_by_freq   66]}}\
   {kybs {[get_key_by_freq   33]}}\
   {kybs {[get_key_by_freq 16.5]}}\
  }}\
  {csym {(1:1,25:24,9:8,6:5,5:4,4:3,25:18,3:2,8:5,5:3,9:5,15:8)}\
   cmod r............}\
 }}\
 {rept 18 more {\
  {song {} vars {\
   {kybs -36}\
   {kybs -24}\
   {kybs -12}\
   {kybs   0}\
   {kybs  12}\
   {kybs  24}\
   {kybs  36}\
   {kybs  48}\
   {kybs  60}\
  }}\
  {csym (0,1,2,3,4,5,6,7,8,9,10,11)\
   cmod ............}\
 }}\
 {rept 18 more {\
  {song {} vars {\
   {kybs  60}\
   {kybs  48}\
   {kybs  36}\
   {kybs  24}\
   {kybs  12}\
   {kybs   0}\
   {kybs -12}\
   {kybs -24}\
   {kybs -36}\
  }}\
  {csym (0,1,2,3,4,5,6,7,8,9,10,11)\
   cmod r............}\
 }}\
 {rept 18 more {\
  {song {} vars {\
   {kybs -36}\
   {kybs -24}\
   {kybs -12}\
   {kybs   0}\
   {kybs  12}\
   {kybs  24}\
   {kybs  36}\
   {kybs  48}\
   {kybs  60}\
  }}\
  {csym {(0,1,2,3,4,5,6,7,8,9,10,11)|(1:1,25:24,9:8,6:5,5:4,4:3,25:18,3:2,8:5,5:3,9:5,15:8)}\
   cmod ............/............}\
 }}\
 {rept 18 more {\
  {song {} vars {\
   {kybs  60}\
   {kybs  48}\
   {kybs  36}\
   {kybs  24}\
   {kybs  12}\
   {kybs   0}\
   {kybs -12}\
   {kybs -24}\
   {kybs -36}\
  }}\
  {csym {(0,1,2,3,4,5,6,7,8,9,10,11)|(1:1,25:24,9:8,6:5,5:4,4:3,25:18,3:2,8:5,5:3,9:5,15:8)}\
   cmod r............/r............}\
 }}\
 {rept 18 tmtv 4 more {\
  {song {} vars {\
   {kybs -36}\
   {kybs -24}\
   {kybs -12}\
   {kybs   0}\
   {kybs  12}\
   {kybs  24}\
   {kybs  36}\
   {kybs  48}\
   {kybs  60}\
  }}\
  {csym {( 0.00, 0.25, 0.50, 0.75, 1.00, 1.25, 1.50, 1.75,\
           2.00, 2.25, 2.50, 2.75, 3.00, 3.25, 3.50, 3.75,\
           4.00, 4.25, 4.50, 4.75, 5.00, 5.25, 5.50, 5.75,\
           6.00, 6.25, 6.50, 6.75, 7.00, 7.25, 7.50, 7.75,\
           8.00, 8.25, 8.50, 8.75, 9.00, 9.25, 9.50, 9.75,\
          10.00,10.25,10.50,10.75,11.00,11.25,11.50,11.75)}\
   cmod ................................................}\
 }}\
 {rept 18 tmtv 4 more {\
  {song {} vars {\
   {kybs  60}\
   {kybs  48}\
   {kybs  36}\
   {kybs  24}\
   {kybs  12}\
   {kybs   0}\
   {kybs -12}\
   {kybs -24}\
   {kybs -36}\
  }}\
  {csym {( 0.00, 0.25, 0.50, 0.75, 1.00, 1.25, 1.50, 1.75,\
           2.00, 2.25, 2.50, 2.75, 3.00, 3.25, 3.50, 3.75,\
           4.00, 4.25, 4.50, 4.75, 5.00, 5.25, 5.50, 5.75,\
           6.00, 6.25, 6.50, 6.75, 7.00, 7.25, 7.50, 7.75,\
           8.00, 8.25, 8.50, 8.75, 9.00, 9.25, 9.50, 9.75,\
          10.00,10.25,10.50,10.75,11.00,11.25,11.50,11.75)}\
   cmod r................................................}\
 }}\
 ;
begin $root "[file rootname [file tail $argv0]]" 0.5;
touch $stem 170;
end $root 3.0;
